/**
 * Informatique Industrielle et Java
 * Projet montre du chapitre4
 *  
 * @author F. Mallet
 * @version 1
 */
import java.awt.Point;
public class Aiguille {
    /* longueur de l'aiguille en nombre de pixels */
    private double longueur;
    /* nombre de cran dans le tour complet de la montre */
    private int max;
    /* centre de la montre sur laquelle l'aiguille est dessin?e */
    private int x, y;

    public Aiguille(int max, double longueur, int x, int y) {
        this.max = max;
        this.longueur = longueur;
        this.x = x;
        this.y = y;
    }
    /** dessine l'aiguille avec une certaine position dans un espace 
    * graphique. On consid?re que 5% de la longueur de l'aiguille est 
    * dessin?e d'un c?t? du centre, 95% de l'autre c?t?
* @param position de l'aiguille, 0?position<12 
*/
    public void dessine(int position, java.awt.Graphics g) {
        // calcul de l'angle entre l'aiguille et la verticale
        double angle = (2*Math.PI*position)/max;

        // calcul de la position du bout de l'aiguille
        Point bout = calculBout(angle, longueur*0.95);
        
        // calcul de la position du bout de l'aiguille pr?s du centre
        Point centre = calculBout(angle, -longueur*0.05);

        // dessine l'aiguille entre les deux points
        g.drawLine(centre.x, centre.y, bout.x, bout.y);
    }
    /** Cette m?thode calcul la position d'un point dont les coordonn?es
     * g?om?trique par rapport au centre de la montre sont donn?es par 
     * une distance est un angle. 
     * @param angle que forme l'aiguille par rapport ? la verticale
     * @param distance par rapport au centre de la montre
     */
    private Point calculBout(double angle, double distance) {
    // calcul l'abscisse
        double abscisse = x+distance*Math.sin(angle); 
        // calcul l'ordonn?e
        double ordonnee = y-distance*Math.cos(angle);
        return new Point((int)abscisse, (int)ordonnee);
    }
}
